//
//  ArteOGLAnimationImage.h
//  ArteOGL
//
//  Created by touta on 09/02/13.
//  Copyright 2009 TSBps. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ArteOGLObject.h"
#import "ArteOGLImage.h"
#import "ArteOGLImageTexture.h"

typedef enum{
	ArteOGLAnimationImageLoop,
	ArteOGLAnimationImageReturnLoop,
	ArteOGLAnimationImageOnce
}ArteOGLAnimationImageMode;

@interface ArteOGLAnimationImage : ArteOGLObject {
	ArteOGLAnimationImageMode animationmode;
	ArteOGLImageTexture **frames;
	long framelength;
	long intervalframe;
	long currentframe;
	long currentwait;
	int currentdirection;
}
- (id)initWithTextures:(NSArray *)array mode:(ArteOGLAnimationImageMode)mode interval:(long)intervalFrames;
- (id)initWithTexture:(ArteOGLImageTexture *)tex row:(int)row column:(int)col mode:(ArteOGLAnimationImageMode)mode interval:(long)intervalFrames;
- (id)initWithTextureNamed:(NSString *)imgname row:(int)row column:(int)col mode:(ArteOGLAnimationImageMode)mode interval:(long)intervalFrames;

@end
