/*
 *  ArteOGLDefines.h
 *  ArtesemaOGL
 *
 *  Created by touta on 08/08/09.
 *  Copyright 2008 TSBps. All rights reserved.
 *
 *  Defines of Static value.
 *
 */


enum{
	ArteOGLHorizontal = 0,
	ArteOGLVertical
};
enum{
	ArteOGLLeft = 0,
	ArteOGLBottom,
	ArteOGLRight,
	ArteOGLTop
};

enum{
	ArteOGLNorth = ArteOGLTop,
	ArteOGLEast = ArteOGLRight,
	ArteOGLWest = ArteOGLLeft,
	ArteOGLSouth = ArteOGLBottom,
	
	ArteOGLSouthWest = 4,
	ArteOGLSouthEast,
	ArteOGLNorthEast,
	ArteOGLNorthWest,
};

#pragma mark CoordMode
// ArteOGL CoordMode
//	for Virtual-Coord
//
// bit0:Reserved
// bit1:use virtual-x
// bit2:use virtual-y
typedef unsigned int ArteOGLObjectCoordMode;
#define ArteOGLObjectSystemCoordMode 0
	// Not use virtual coord
#define ArteOGLObjectVirtualHorizontalCoordMode 0x2
	// Use virtual X coord
#define ArteOGLObjectVirtualVerticalCoordMode 0x4
	// Use virtual Y coord
#define ArteOGLObjectVirtualCoordMode 0x6
	// Use virtual XY coord

// = - = - = ArteScrollMode
typedef unsigned int ArteOGLScrollMode;
enum{
	ArteOGLNonScrollMode = 0,
	ArteOGLForceScrollMode,
	ArteOGLFocusScrollMode,
	ArteOGLTargetScrollMode,
	ArteOGLRandomScrollMode,
	
};


// ArteTeam
#pragma mark ArteTeam
typedef unsigned int ArteOGLObjectTeam;
enum{
	ArteNonTeam,
	ArteAlphaTeam,
	ArteBetaTeam,
	ArteGammaTeam,
	ArteDeltaTeam,
	ArteEpsilonTeam
};


#pragma mark ArteObjectLevelEffect
//ArteObjectLevelEffect
enum{
	ArteOLEShakeWithX = 0,
	ArteOLEShakeWithY = 1,
	ArteOLEShakeWithFraction = 2
};
/**  use ArteOGLLeft,ArteOGLBottom,ArteOGLRight,ArteOGLTop instead.
enum{
	ArteOLELimitUpperOfX = 0,
	ArteOLELimitBottomOfX = 1,
	ArteOLELimitUpperOfY = 2,
	ArteOLELimitBottomOfY = 3
};
**/
typedef enum{
	ArteOLELimitKeep = 0,
	ArteOLELimitStop,
	ArteOLELimitBounce
} ArteOLELimitType;
enum{
	ArteOLEFlipInXCenter = 10,
	ArteOLEFlipInXRight = 11,
	ArteOLEFlipInXLeft = 12,
	ArteOLEFlipInYCenter = 15,
	ArteOLEFlipInYRight = 16,
	ArteOLEFlipInYLeft = 17,
	ArteOLEFlipOutXCenter = 20,
	ArteOLEFlipOutXRight = 21,
	ArteOLEFlipOutXLeft = 22,
	ArteOLEFlipOutYCenter = 25,
	ArteOLEFlipOutYRight = 26,
	ArteOLEFlipOutYLeft = 27
};


#pragma mark speedlimit
//Maximam Speed of
extern float ArteOGLSpeedLimitX;
extern float ArteOGLSpeedLimitY;


#pragma mark life
//
#define ArteOGLObjectEternalLife -1
#define ArteOGLObjectHereafterLife -2


#pragma mark BlendMode
//
typedef unsigned int ArteOGLViewBlendMode;
enum {
	ArteOGLViewSourceOverBlendMode	= 0,//UWAGAKI
	ArteOGLViewCopyBlendMode,			//UWAGAKI-WITHOUT-ALPHA
	ArteOGLViewAddBlendMode,			//KA-SAN
	ArteOGLViewSubBlendMode,			//GEN-SAN
	ArteOGLViewMulBlendMode,			//JOU-SAN
	ArteOGLViewCompareDarker,			//HIKAKU-KURAI
	ArteOGLViewCompareLighter,			//HIKAKU-AKARUI
	ArteOGLViewInvertBlendMode,			//HANTEN
	ArteOGLViewScreenBlendMode,			//SCREEN
	ArteOGLViewXORBlendMode,			//XOR
	ArteOGLViewEraseBlendMode,			//KESI
	ArteOGLViewTest1BlendMode,
	ArteOGLViewTest2BlendMode,
	ArteOGLViewTest3BlendMode,
	ArteOGLViewTest4BlendMode,
	ArteOGLViewTest5BlendMode,
};

#pragma mark string size/fade
extern float ArteOGLStringTextureMaximamWidth;
extern int ArteOGLStringFadeBaseDuration;
extern float ArteOGLStringFadeWidthSpeed;
extern float ArteOGLStringFadeHeightSpeed;

typedef enum{
	// Using blank space of unicode
	//	0xF900 - 0xFAFF : CJK Compatibility Ideographs
	ArteOGLCommandKey = 0xFADA,
	ArteOGLShiftKey,
	ArteOGLKeyCapslockKey,
	ArteOGLOptionKey,
	ArteOGLControlKey,
	ArteOGLFnKey
} ArteOGLModifierKey;

