//
//  ArteOGLImage.h
//  ArtesemaOGL
//
//  Created by touta on 06/02/26.
//  Copyright 2006 TSBps. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glext.h>
#import "ArteOGLObject.h"
#import "ArteOGLImageTexture.h"
#import "ArteOGLImageTextureClip.h"

//SWITCH USE SHARE CACHE OR NOT

@interface ArteOGLImage : ArteOGLObject {
	ArteOGLImageTexture *texture;
}

#pragma mark TextureCache Manage
+ (BOOL)cacheTextureNamed:(NSString *)name;
	// load image as shared-texture to cache
	// return
	//		YES: successly cached.
	//		NO: fail to cache.
+ (BOOL)isTextureCached:(NSString *)name;
	// is image already in cache?
	// return
	//		YES: Already cached.
	//		NO: Not cached yet.
+ (BOOL)shareTexture:(ArteOGLImageTexture *)tex forName:(NSString *)name;
	// regist texture to cache as shared-texture
	//	If you want to share image as variational texture like imageTexture2N,
	//	create texture and regist it with this method.
+ (ArteOGLImageTexture *)sharedTextureNamed:(NSString *)name;
	// get share-managed texture
	//	Some object use this method to get image-texture to custom draw in their turn.
+ (void)clearSharedTextures;
	// clear cache
	//	User should call this method to clear memory.
	//	Better to call at proper time.
+ (NSMutableDictionary *)aliases;
	// alias name dictionary

#pragma mark initialize -with texture caching
+ (id)objectWithImageNamed:(NSString *)name;
	// get image object with shared texture.
	//	Normally, call this method to get image object.

- (id)initWithImageNamed:(NSString *)name;

#pragma mark initialize -without caching
- (id)initWithNSImage:(NSImage *)img;
- (id)initWithTexture:(ArteOGLImageTexture *)texobj;

#pragma mark texture manage
- (void)switchTexture:(ArteOGLImageTexture *)texobj resize:(BOOL)resize;
// replace texture holding with given new texture.

#pragma mark values
- (NSSize) imageSize;
- (CGSize) textureSize;
- (ArteOGLImageTexture *) texture;
@end
