//
//  ArteOGLObject_resource.h
//  ArteOGL
//
//  Created by touta on 09/06/23.
//  Copyright 2009 TSBps. All rights reserved.
//

#import "ArteOGLObject.h"

// ArteOGLObject ( resource )
//
// Those methods make possible to use external (not in bundle) resource.
// If resourceFolder haven't set, search resource in mainBundle.
// Else search in specified resourceFolder.
//
//	****
//	Subclass of ArteOGLObject should use [[self class] pathForResource: ofTypes:]
//	insted of[[NSBundle mainBundle] pathForResource: ofType:]
//	****


@interface ArteOGLObject (resource)

// set/get resourceFolder
+ (void)setResourceFolder:(NSString *)folderpath;
+ (NSString *)resourceFolder;

// get resource for types.
+ (NSString *)pathForResource:(NSString *)name ofTypes:(NSArray *)extentions;
//	filename:	name of resource file
//	types:		list of extensions to select


@end
