//
//  ArteOGLScene.h
//  ArteOGL_Artesema
//
//  Created by touta on 09/02/02.
//  Copyright 2009 TSBps. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ArteOGLViewProtocol.h"

@interface ArteOGLScene : NSObject {
	ArteOGLScene *nextscene;
}

+ (id)sceneWithNextScene:(ArteOGLScene *)scene;

#pragma mark scene manage
- (void)setNextScene:(ArteOGLScene *)scene;
- (ArteOGLScene *)nextScene;
- (BOOL)canEnd; //ask allow shift to another scene or not.
- (BOOL)didEnd; //if returns YES, scene will shift to next by sceneController
- (void)sceneWillBeginWith:(id <ArteOGLViewProtocol>)view;
- (void)sceneDidEndWith:(id <ArteOGLViewProtocol>)view;

#pragma mark calc and draw
// follows will be called at 
- (void)OGLcalc:(id <ArteOGLViewProtocol>)arteview; //calcuration method
- (void)OGLdraw:(id <ArteOGLViewProtocol>)arteview; //drawing method.

#pragma mark object manage
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view objectDied:(id)obj;
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view objectOvered:(id)obj;

#pragma mark event
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view keyPressed:(unichar)key;
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view keyReleased:(unichar)key;

- (void)ArteOGL:(id <ArteOGLViewProtocol>)view mousePressed:(CGPoint)pt;
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view mouseReleased:(CGPoint)pt;


@end
