//
//  ArteOGLShape.h
//  ArteOGL
//
//  Created by touta on 09/10/22.
//  Copyright 2009 TSBps. All rights reserved.
//

#import <OpenGL/OpenGL.h>
#import "ArteOGLObject.h"

enum{
	ArteOGLShapeStoroke = 0,
	ArteOGLShapeFill = 1,
};

@interface ArteOGLShape : ArteOGLObject {
	float texcolor[3];
	float linewidth;
	int shapefill;
}

+ (id)objectWithRectFill:(CGRect)rect;
+ (id)objectWithRectFrame:(CGRect)rect;

- (id)initWithRect:(CGRect)rect;

- (void)setShapeFill:(int)fill;
- (int)shapeFill;

- (void)setColor:(NSColor *)col;
- (void)setColorWithGlayscale:(float)gs;
- (void)setColorWithR:(float)r G:(float)g B:(float)b;

- (void)setLineWidth:(float)width;
- (float)lineWidth;

@end
