/*
 *  ArteOGLViewDelegateProtocol.h
 *  ArteOGL
 *
 *  Created by touta on 08/11/12.
 *  Copyright 2008 TSBps. All rights reserved.
 *
 */

//#import "ArteOGLView.h"
@class ArteOGLView;

@protocol ArteOGLViewDelegateProtocol

#pragma mark registration
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view registerAsDelegate:(id)controller;
	// 


#pragma mark event
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view keyPressed:(unichar)key;
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view keyReleased:(unichar)key;
	// key: key code
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view mousePressed:(CGPoint)pt;
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view mouseReleased:(CGPoint)pt;
	// pt: mouse point in view


#pragma mark interrupt
- (void)ArteOGLdidCalculate:(id <ArteOGLViewProtocol>)view;
- (void)ArteOGLdidDraw:(id <ArteOGLViewProtocol>)view;

#pragma mark delegate
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view objectDied:(id)obj;
	// called before object-removing from view
- (void)ArteOGL:(id <ArteOGLViewProtocol>)view objectOvered:(id)obj;
	// called object passed over limit of stage
//- (void)ArteOGL:(ArteOGLView *)view object:(id)obj;

- (void)ArteOGLdrawPause:(id <ArteOGLViewProtocol>)view;

#pragma mark behavior
- (uint)ArteOGLfps:(id <ArteOGLViewProtocol>)view;
	// return FPS of drawing
- (BOOL)ArteOGLkeepAspectRatioWhenFullScreen:(id <ArteOGLViewProtocol>)view;
	// return whether keep aspect ratio when fullscreen 
- (BOOL)ArteOGLhandlePauseKeyEventInView:(id <ArteOGLViewProtocol>)view;
	// return whether allow view to handle pause key event or not.
	//	'p': toggle pause
	//	
	//	Notice: if return YES, view never pass the event while pausing.
	//	If you want to handle key event while pausing, 
	//	
- (BOOL)ArteOGLhandleFullScreenKeyEventInView:(id <ArteOGLViewProtocol>)view;
	// return whether allow view to handle fullscreen key event or not.
	//	'^': start fullscreen
	//	'-': end fullscreen
	//	ESC: end fullscreen
- (BOOL)ArteOGLhandleArrowKeyEvent:(id <ArteOGLViewProtocol>)view;
	//return whether handle arrow key event or not.
	//	In most cases you should return YES;
	//	Only if you want to use ArteOGL-HID for key event handling: just return NO;
@end

