//
//  ArteObjectBehavior.h
//  ArteOGL
//
//  Created by touta on 11/08/10.
//  Copyright 2011 TSBps. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ArteOGLObject.h"

@interface ArteObjectBehavior : NSObject {
	ArteObjectBehavior *continuousBehavior;	//retain
	ArteObjectBehavior *nextBehavior;		//retain
	int lifecount; //decremented in applyBehavir and behavior will die when count become 0. [default: -1(means infinity)]
}

- (void)applyBehaviorToObject:(ArteOGLObject *)obj
				afterBehavior:(ArteObjectBehavior *)prevBehavior;
	//will called

- (void)addBehaviorToChainEnd:(ArteObjectBehavior *)behav;

- (void)setLifecount:(int)count;
- (long)lifecount;

- (ArteObjectBehavior *)continuousBehavior;
- (void)setContinuousBehavior:(ArteObjectBehavior *)behavior;
//continuous for behavior-chain

- (ArteObjectBehavior *)nextBehavior;
- (void)setNextBehavior:(ArteObjectBehavior *)behavior;
//next behavior will replace myself in behavior-chain when myself dies.

@end
